/*	Copyright (C) 2003-2015 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_LengthCorrectOp_h__
#define __operator_LengthCorrectOp_h__

namespace fe
{

/**************************************************************************//**
	@brief Handler to resize curve segments to match an original

	@ingroup operator
*//***************************************************************************/
class FE_DL_EXPORT LengthCorrectOp:
	public OperatorThreaded,
	public Initialize<LengthCorrectOp>
{
	public:

					LengthCorrectOp(void):
						m_frame(-1.0)										{}
virtual				~LengthCorrectOp(void)									{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);
virtual	void		run(I32 a_id,sp<SpannedRange> a_spRange);

	private:

		BWORD		relength(I32 a_id,sp<SpannedRange> a_spRange);
		BWORD		suspendAndCollide(I32 a_id,sp<SpannedRange> a_spRange);
		BWORD		reroute(I32 a_id,sp<SpannedRange> a_spRange);

		BWORD		collidePoint(SpatialVector a_point,
						SpatialVector a_target,SpatialVector a_dir,
						Real a_scalar,SpatialVector& a_rPush);

		sp<SurfaceAccessibleI>	m_spInputAccessible;
		sp<SurfaceAccessibleI>	m_spReferenceAccessible;
		sp<SurfaceAccessibleI>	m_spOutputAccessible;
		sp<SurfaceAccessibleI>	m_spColliderAccessible;
		sp<SurfaceI>			m_spDriver;
		sp<SurfaceI>			m_spCollider;

		sp<DrawI>				m_spDrawDebug;

		Real					m_frame;
		Array<SpatialVector>	m_pointCache;
		Array<SpatialVector>	m_velocityCache;
};

} /* namespace */

#endif /* __operator_LengthCorrectOp_h__ */
