import sys
forge = sys.modules["forge"]

def setup(module):
	srcList = [	"SurfaceAccessibleXGen",
				"xgen.pmh",
				"xgenDL" ]

	dll = module.DLL( "fexXGenDL", srcList )

	# TODO multiple versions
	maya_root = "/usr/autodesk/maya"
	maya_source_count = len(forge.maya_sources)
	if maya_source_count > 0:
		maya_root = forge.maya_sources[maya_source_count-1][1] + "/.."

	module.includemap = {}
	module.includemap['maya'] = maya_root + '/include'
	module.includemap['xgen'] = maya_root + '/plug-ins/xgen/include'
	module.includemap['xgen2'] = maya_root + '/plug-ins/xgen/include/xgen'
	module.includemap['xgen3'] = maya_root + '/plug-ins/xgen/include/XGen'

	dll.linkmap = {}
	dll.linkmap['xgen'] = '-L' + maya_root + '/plug-ins/xgen/lib'
	dll.linkmap['xgen'] += ' -lAdskXGen'

	deplibs = forge.corelibs+ [
				"fexSurfaceDLLib" ]

	forge.deps( ["fexXGenDLLib"], deplibs )

	forge.tests += [
		("inspect.exe",		"fexXGenDL",	None,		None) ]

	module.Module('test')
